/**
 * Prototype javascript effects for showing
 * 
 * @package Templates
 * @author  Andreas Goetz   <cpuidle@gmx.de>
 * $Id: show.js,v 1.3 2008/03/01 10:05:12 andig2 Exp $
 */

/**
 * Seen
 */
function bindSeen(id)
{
    $('seen').observe('click', function(event) {
        $('indicator1').setStyle({display: 'inline'});

        new Ajax.Request('show.php', {
            parameters: {ajax_update: id, seen: ($('seen').checked) ? 1 : 0},

            onSuccess: function(transport, json) {
                $('indicator1').setStyle({display: 'none'});
                $('seen').checked = json.result;
                $('seen_label').setStyle({display: (json.result) ? 'inline' : 'none'});
            }
        });
    });
}

/**
 * Rating
 */
function bindRating(id, url, control, control_val, val, editable)
{
    var rating = new Control.Rating(control, {updateUrl: url, updateParameterName: 'rating', value: val,
        rated: false, multiple: true, max:10, capture: true,
        parameters: {ajax_update: id},
        
        onChange: function(value) {
            $('indicator1').setStyle({display: 'inline'});
        },
        
        afterChange: function(value) {
            $('indicator1').setStyle({display: 'none'});
            $(control_val).update(value);
            this.options.rated = false;
        }.bind(this)
    });
    
    if (!editable) rating.disable();
}

/**
 * Youtube
 */
function bindYoutube(title)
{
    $('indicator1').setStyle({display: 'inline'});

    new Ajax.Request('show.php', {
        parameters: {ajax_youtube: title},

        onSuccess: function(transport, json) {
            $('indicator1').setStyle({display: 'none'});
            if (json.result) $('youtube').setStyle({display: 'inline'});
        }
    });
}
